/***************************************************************************
 *
 * Copyright (C) 2001 International Business Machines
 * All rights reserved.
 *
 * This file is part of the GPFS mmfslinux kernel module.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions 
 * are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice, 
 *     this list of conditions and the following disclaimer. 
 *  2. Redistributions in binary form must reproduce the above copyright 
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution. 
 *  3. The name of International Business Machines may not be used to endorse 
 *     or promote products derived from this software without specific prior 
 *     written permission. 
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS "AS IS" AND ANY 
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR 
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Alternatively, provided that this notice is retained in full, this
 * software may be distributed under the terms of the GNU General
 * Public License ("GPL") as published by the Free Software Foundation;
 * either version 2 of the License, or (at your option) any later version,
 * in which case the provisions of the GPL apply INSTEAD OF those given above.
 *
 ****************************************************************************/
#ifndef _h_qosio_k
#define _h_qosio_k
/* qosio-k.h
   Some qosio definitions -
    separated from qosio.h so they can be included where all
    the other qosio.h complexities are not required and/or may
    be detrimental to portable kernel code.
*/

/* magic and daemon thread qosid values */
/* high order byte is used to group similar activities for first order or course analysis */

/* class BC - uninitialized qosid - might bear investigation */
#define QOSID_U_WORKER   0xBCBBBB02  /* uninit .. in WorkerParms */
#define QOSID_U_MAILBOX  0xBCBBBB03  /* .. in Mailbox */
#define QOSID_U_DISKIO   0xBCBBBB04  /* .. in iop Mailbox */
#define QOSID_U_OPENINST 0xBCBBBB05  /* .. in OpenInstance */
#define QOSID_U_INODEPRE 0xBCBBBB06  /* .. in InodePrefetchInstance */
#define QOSID_U_BUFDESC  0xBCBBBB11  /* uninitialized qosid in BufferDesc */
#define QOSID_U_BUFDCLN  0xBCBBBB12  /* similar .. but buffer was cleaned */

 /* class BA - "anonymous" */
#define QOSID_U_RELNQABR 0xBABBBB13  /* anonymous ReliquishAttrByteRange */
#define QOSID_U_ANON     0xBADF0000  /* QosIoMon | anonymous qosid counter */

/* class BF - flush, but application to charge has gone */
#define QOSID_U_FLUSH    0xBFBBBB07  /* flushFile with NULL OpenFile* or OpenInstance* */

/* class D0 - pit stuff */
#define QOSID_PITBASE    0xD0000000  /* qosid = QOSID_PITBASE + (PitForWhat value) */

/* class D1 - various Daemon stuff */
#define QOSID_STRPG_BASE 0xD1100001  /* StripeGroupCfg::exceptionHandlerBody + whichException */
#define QOSID_SYNC_WDOG  0xD1200002  /* SFSSyncWatchdogMain */
#define QOSID_DISK_INIT  0xD1300003  /* StripeGroup::DoDiskInit */
#define QOSID_LOGWRAP    0xD1400004  /* LogFile::wraparoundHelperThreadBody */
#define QOSID_RECOVERY   0xD1500005  /* InodeManagerRecovery */
#define QOSID_COMMAND    0xD1600006  /* HandleCmdMsg */
#define QOSID_DEALLOC    0xD1700007  /* DeallocHelperThreadBody */

#define QOSID_MULTI      0xD1D00000  /* qosid = QOSID_MULTI | ThreadName enumerator - see ThreadNames.h */

/* class A - charged to a user process */
#define QOSID_A_PROCESS  0xA0000000  /* qosid = user process w/o ionice value */

#endif /* _h_qosio_k */
